//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  PaleVioletRed
#property indicator_width1  2

//
//
//
//
//

extern int    AverageLength = 14;
extern int    AveragePrice  = PRICE_CLOSE;
extern double Variance      = 1;
extern double Mean          = 0.0;

double  pdfma[];
double  coeffs[];

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

#define maxx 3.5
int init()
{
   SetIndexBuffer(0,pdfma);
      Variance = MathMax(Variance,0.01);
      Mean     = MathMax(MathMin(Mean,1.0),-1.0);
      ArrayResize(coeffs,AverageLength);   
         double step = maxx/(AverageLength-1); for(int i=0; i<AverageLength; i++) coeffs[i] = pdf(i*step,Variance,Mean*maxx);
   return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

         //
         //
         //
         //
         //
         
   for(int i=limit; i>=0; i--) pdfma[i] = iPdfma(iMA(NULL,0,1,0,MODE_SMA,AveragePrice,i),AverageLength,coeffs,i);
   return(0);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//    normal probability density function
//
//

#define Pi 3.141592653589793238462643

double pdf(double x, double variance=1.0, double mean=0)
      { return((1.0/MathSqrt(2*Pi*MathPow(variance,2))*MathExp(-MathPow(x-mean,2)/(2*MathPow(variance,2))))); }

//
//
//
//
//

double workPdfma[][1];
double iPdfma(double price, double period, double& coeffs[], int r, int instanceNo=0)
{
   if (ArraySize(workPdfma)!= Bars) ArrayResize(workPdfma,Bars); r = Bars-r-1;
   
   //
   //
   //
   //
   //
   
   workPdfma[r][instanceNo] = price;
      double sumw = coeffs[0];
      double sum  = coeffs[0]*price;

      for(int k=1; k<period && (r-k)>=0; k++)
      {
         double weight = coeffs[k];
                sumw  += weight;
                sum   += weight*workPdfma[r-k][instanceNo];  
      }             
      return(sum/sumw);
}

